<script>
    import '../../../app.css';

    /** @type {import('./$types').PageData} */
    export let data;

    //parse response from peerplays mint api
    let { nft_full } = data.HTMLDATA;

    //parse nft_full.names as names
    export /**
     * @type {any}
     */
    let names = nft_full.names;

    //returns account name if it is in the names dictionary, else returns the account id unaltered.
    export function id_or_name(id) {
        return id in names ? names[id] : id;
    }

    //returns href link to user account '/u/user-name', if account name is in names dictionary. Else, link to user-id '/u/[iid]'.
    export function id_or_name_link(id) {
        return id in names ? '/u/' + names[id] : '/u/' + id.split('.')[2];
    }

    //returns href link to collection
    export function collection_link(id) {
        return '/nft/m/' + id.split('.')[2];
    }

    //parse nft id and nft_metadata_id
    let nft_id = nft_full.id;
    let nft_metadata_id = nft_full.objects[nft_id].nft_metadata_id;

    //parse nft metadata object and nft object
    let nft_metadata_obj = nft_full.objects[nft_metadata_id];
    let nft_full_obj = nft_full.objects[nft_id];

    //try to return string as json object. Returns false if string is invalid json.
    export function tryJsonParse(str) {
        try {
            let json_obj = JSON.parse(str);
            if (json_obj && typeof json_obj == 'object') {
                return json_obj;
            }
        } catch (e) {}
        return false;
    }

    //try to parse base_uri and token_uri string as json object. Obj is false if string is invalid json.
    let base_uri_obj = tryJsonParse(nft_metadata_obj.base_uri);
    let token_uri_obj = tryJsonParse(nft_full_obj.token_uri);

    //parse series name from base_uri and nft name from token_uri if they are valid json and contain a name field.
    //else, fallback on nft metadata object name.
    let series_name = base_uri_obj && base_uri_obj.name ? base_uri_obj.name : nft_metadata_obj.name;
    let nft_name = token_uri_obj && token_uri_obj.name ? token_uri_obj.name : nft_metadata_obj.name;
</script>

<section id="nftdetails">
    <div class="container mx-auto space-y-4 pb-4">
        <div class="flex flex-row justify-between space-x-4 justify-items-start ">
            <!-- NFT Image -->
            <div class="basis-2/5 border border-sky-500 py-5 px-3">Image Card</div>

            <!-- Identifiers -->
            <div class="basis-3/5 border border-sky-500 py-5 px-3 h-min">
                <!-- series name -->
                <h1 class="text-xl font-medium text-slate-800 mb-2">
                    <a
                        class=" break-all hover:text-sky-500"
                        href={collection_link(nft_metadata_id)}
                    >
                        {series_name.length > 56 ? series_name.substr(0, 56) + '...' : series_name}
                    </a>
                </h1>

                <!-- nft name -->
                <h3 class="text-md peer break-all">
                    {nft_name.length > 80 ? nft_name.substr(0, 80) + '...' : nft_name}
                </h3>
                {#if nft_name != nft_metadata_obj.name}
                    <div
                        class="invisible bg-slate-50 text-slate-900 rounded-md p-3 border-1 border-slate-200 peer-hover:visible border"
                    >
                        <h6 class="font-bold">
                            Token Name: <span class="font-normal">{nft_name}</span>
                        </h6>
                        <h6 class="font-bold">
                            On-Chain Name: <span class="font-normal">{nft_metadata_obj.name}</span>
                        </h6>
                    </div>
                {/if}

                <!-- Owner -->
                <h5 class="text-md text-slate-500 font-normal">
                    Owned by
                    <a
                        class="no-underline break-all text-sky-500 hover:text-sky-700"
                        href={id_or_name_link(nft_full_obj.owner)}
                    >
                        {id_or_name(nft_full_obj.owner)}
                    </a>
                </h5>
            </div>
        </div>

        <div class="flex flex-row space-x-4 ">
            <!-- NFT Description -->
            <div class="basis-2/5 border border-sky-500 py-5 px-3">description</div>

            <!-- Market Data -->
            <div class="basis-3/5 border border-sky-500 py-5 px-3">market data</div>
        </div>

        <!-- More NFTs -->
        <div id="morenfts" class="border border-sky-500 py-5 px-3">more nfts</div>
    </div>
</section>
